<?php

/***************************************************************************
 freeForum @soft.ZoneO.net
 Copyright (C) 2005 ZoneO-soft, S. Merkel (dude@zoneo.net)

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 More Info About The Licence At http://www.gnu.org/copyleft/gpl.html
****************************************************************************/


///////////////////////////////////////////////////////
// Function: microtime_float
////////////////////////////////////////////////////////
function microtime_float() {
	list($usec, $sec) = explode(" ", microtime());
	return ((float)$usec + (float)$sec);
}

///////////////////////////////////////////////////////
// Function: query_string
// Description: Format the Query_String (removes the arguments
//        used by FreeForum, and leave the others)
////////////////////////////////////////////////////////
function query_string($q_string, $strips) {
foreach($strips as $key) {
	$strips[$key] = TRUE;
}
$var_value = explode("&", $q_string);
foreach($var_value as $var_peace){
	$parts = explode("=", $var_peace);
	if($strips[$parts[0]] != TRUE and $parts[0] != "") {
		$my_q .= "$var_peace&amp;";
	}
}
//if( substr($my_q, -5) == "&amp;" ){ $my_q = substr($my_q, 0, -5); }
return $my_q;
}

///////////////////////////////////////////////////////
// Function:	Flooder
// Description: Flood Protection Function
////////////////////////////////////////////////////////
function flooder($ip){
	global $config_flood_time;
	global $path;
	$old_db = file("$path/Data/flood.db.php");
	$new_db = fopen("$path/Data/flood.db.php", w);
	$result = FALSE;
	foreach($old_db as $old_db_line){
		$old_db_arr = explode("|", $old_db_line);
		if(($old_db_arr[0] + $config_flood_time) > time() ) {
			fwrite($new_db, $old_db_line);
			if($old_db_arr[1] == $ip) { $result = TRUE; }
		}
	}
	fclose($new_db);
	return $result;
}

////////////////////////////////////////////////////////
// Function: convert links
// Description: Locate links in a text string
////////////////////////////////////////////////////////
function convert_links($str, $www = false) {
	#this converts http://*  the link ends at the next space, a ' or a " or (if there is no space, ' or ") at the end of the string.
	$str = preg_replace('#(http://)([^\s\'|\"]*)#', '[link=\\1\\2]\\1\\2[/link]', $str);
	#optional, replaces www.*
	if($www) {
		$str = preg_replace('=(www.)([^\s|\'|\"]*)=', '[link=http://\\1\\2]\\1\\2[/link]', $str);
	}
	# Correct the links, if the last char of the URL is a punctuation mark,
	# we probably got it wrong...
	$str = preg_replace("'\[link\=(.*?)\.\]'i", '[link=\\1]', $str);
	$str = preg_replace("'\.\[/link\]'i", '[/link\]\.', $str);
	$str = preg_replace("'\[link\=(.*?)\;\]'i", '[link=\\1]', $str);
	$str = preg_replace("'\;\[/link\]'i", '[/link\]\;', $str);
	$str = preg_replace("'\[link\=(.*?)\,\]'i", '[link=\\1]', $str);
	$str = preg_replace("'\[link\=(.*?)\)\]'i", '[link=\\1]', $str);
	$str = preg_replace("'\,\[/link\]'i", '[/link\]\,', $str);
	return $str;
}

////////////////////////////////////////////////////////
// Function: replace_comments
// Description: Replaces comments characters for proper display
////////////////////////////////////////////////////////
function replace_comment($way, $source,$findURL = false){
	global $strings;
	$quote = $strings['quote'];

	$source = stripslashes(trim($source));
	if($way == "add"){
		// catching links
		if ($findURL) { $source =  convert_links($source,false);};
		$source  = preg_replace("'\r'","",$source);
		//$source  = preg_replace('/\n\n+/', "\n",$source);
		// replacing dangerous characters
		$find = array(
/* 1 */	    			"'\"'",
/* 2 */					"'\''",
/* 3 */					"'<'",
/* 4 */					"'>'",
/* 5 */					"'\|'",
/* 6 */					"'\n'",
/* 7 */					"'\r'",
						);
		$replace = array(
/* 1 */	    			"&quot;",
/* 2 */					"&#039;",
/* 3 */					"&lt;",
/* 4 */					"&gt;",
/* 5 */ 					"&#124;",
/* 6 */					"\n",
/* 7 */					"",
			);
	}
	elseif($way == "show"){
		$find = array(
/* 1 */					"'\[b\](.*?)\[/b\]'i",
/* 2 */					"'\[i\](.*?)\[/i\]'i",
/* 3 */					"'\[u\](.*?)\[/u\]'i",
/* 4 */					"'\[link\](.*?)\[/link\]'i",
/* 5 */					"'\[link=(.*?)\](.*?)\[/link\]'i",
/* 6 */					"'\n'i",
/* 7 */                "/\[quote=(.*?)\]/i",
/* 8 */                "/\[quote\]/i",
/* 9 */						"'\[/quote\]'i"
							);
		$replace = array(
/* 1 */					"<strong>\\1</strong>",
/* 2 */					"<em>\\1</em>",
/* 3 */					"<span style=\"text-decoration: underline;\">\\1</span>",
/* 4 */					"<a href=\"\\1\">\\1</a>",
/* 5 */					"<a href=\"\\1\">\\2</a>",
/* 6 */					"\n<br>",
/* 7 */				"\n<blockquote><b>\\1</b> $quote:<br>",
/* 8 */				"\n<blockquote>",
/* 9 */				"\n</blockquote>"
							);
	} elseif ($way == "edit"){
		$find = array(
/* 4 */					"'\[link\](.*?)\[/link\]'i",
/* 5 */					"'\[link=(.*?)\](.*?)\[/link\]'i"
							);
		$replace = array(
/* 4 */					"\\1",
/* 5 */					"\\1"
							);
	}
	$source  = preg_replace($find,$replace,$source);
	return $source;
}

///////////////////////////////////////////////////////////////////////////
// Function: check_ip_address
// Description: Make sure that we have an IP
// Found on  the PHP website
// Returns TRUE or FALSE 
//    check_ip_address('125.32.15.0') is TRUE check_ip_address('125.32.15.*') is FALSE 
//    check_ip_address('125.32.15.*', '*') is TRUE check_ip_address('*.*.*.*', '*') is TRUE 
//    check_ip_address('125.-.15.2', '-') is TRUE 
///////////////////////////////////////////////////////////////////////////

function check_ip_address($checkip, $jolly_char='') {
	if ($jolly_char=='.')  // dot ins't allowed as jolly char
		$jolly_char = '';
	if ($jolly_char!='') {
		$checkip = str_replace($jolly_char, '*', $checkip);  
			// replace the jolly char with an asterisc
		$my_reg_expr = "^[0-9\*]{1,3}\.[0-9\*]{1,3}\.[0-9\*]{1,3}\.[0-9\*]{1,3}$";
		$jolly_char = '*';
	}
	else
		$my_reg_expr = "^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$";
	if (eregi($my_reg_expr, $checkip)) {
		for ($i = 1; $i <= 3; $i++) {
				if (!(substr($checkip, 0, strpos($checkip, ".")) >= "0" && substr($checkip, 0, strpos($checkip, ".")) <= "255")) {
					if ($jolly_char!='') {            // if exists, check for the jolly char
						if (substr($checkip, 0, strpos($checkip, "."))!=$jolly_char)
								return false;
					}
					else
						return false;
				}
				$checkip = substr($checkip, strpos($checkip, ".") + 1);
		}
		
		if (!($checkip >= "0" && $checkip <= "255")) {        // class D
				if ($jolly_char!='') {            // if exists, check for the jolly char
					if ($checkip!=$jolly_char)
						return false;
				}
				else
					return false;
		}
	}
	else
		return false;

	return true;
}


////////////////////////////////////////////////////////
// Function: checkmessage
// Description: Make sure that we can post
//    Tests the subject, text, name, and email 
//    Tests flood protection
//    Tests IP bans
////////////////////////////////////////////////////////
function checkmessage($subject,$name,$email,$text,$ip) {
	global $config_flood_time;
	global $strings;
	global $reserved;
	global $admin;
	global $path;
	// Check Flood Protection
	if($config_flood_time != 0 and $config_flood_time != "" ) {
	if(flooder($ip) == TRUE ){
		echo("".$strings['flood']);
		return false;
		}
	}
	// Check if IP is banned
	$blockip = FALSE;
	$old_ips = file("$path/Data/ipban.db.php");
	$new_ips = fopen("$path/Data/ipban.db.php", "w");
	@flock ($new_ips,2);
	foreach($old_ips as $old_ip_line){
				$ip_arr = explode("|", $old_ip_line);
				if($ip_arr[0] != $ip){
				fwrite($new_ips, $old_ip_line);
		}else{
			$countblocks = $ip_arr[1] = $ip_arr[1] + 1;
			fwrite($new_ips, "$ip|$countblocks||\n"); $blockip = TRUE;
		}
	}
	@flock ($new_ips,3);
	fclose($new_ips);
	if($blockip){
		echo("".$strings['ipblocked']);
		return false;
	}
	$comments = replace_comment("add", $comments, true);
	$name = replace_comment("add", preg_replace("/\n/", "",$name));
	$mail = replace_comment("add", preg_replace("/\n/", "",$mail));
	// Check name
	if($name == " " or $name == ""){
		echo("".$strings['namemissing']);
		return false;
	}
	// Check email or url
	if(!preg_match("/^[\.A-z0-9_\-]+[@][A-z0-9_\-]+([.][A-z0-9_\-]+)+[A-z]{1,4}$/", $email)) {
		echo("".$strings['emailmissing']);
		return false;
	}
	// Check comment itself
	if($text == ""){
		echo("".$strings['commentmissing']);
		return false;
	}
	// Check subject
	if($subject == ""){
		echo("".$strings['subjectmissing']);
		return false;
	}
	if (!$admin) {
		if (in_array(strtolower($name), $reserved)) {
			echo("".$strings['namereserved']);
			return false;
		}
	}
	return true;
}

///////////////////////////////////////////////////////////////////////////
// Function: changepost
// Description: Changes in post in the database
///////////////////////////////////////////////////////////////////////////
function changepost($subject,$name,$email,$text,$cat,$time,$msg) {
	global $_SERVER;
	global $tablename, $db;
	
	$name = trim($name);
	if(!$ip){
		if(isset($HTTP_X_FORWARDED_FOR)){ $ip = $_SERVER['HTTP_X_FORWARDED_FOR']; }
		elseif(isset($HTTP_CLIENT_IP))	{ $ip = $_SERVER['HTTP_CLIENT_IP']; }
		if($ip == "") { $ip = $_SERVER['REMOTE_ADDR']; }
		if($ip == "") { $ip = "not detected";}
	}
	
	// Check the message (flood protection, content, IP ban...)
	if (!checkmessage($subject,$name,$email,$text,$ip)) return 0;
	
	// If it's ok, change it in the database
	$subject = stripslashes($subject);
	$name = stripslashes($name);
	$email = stripslashes($email);
	$text = stripslashes($text);
	$text = replace_comment("add", $text,true);
	$oldinfo = getthreadinfo($msg);
	
	// This is true for all messages
	
	$sql = "UPDATE `$tablename` SET subject='$subject',author='$name', email='$email', message='$text',date=$time WHERE pid=$msg";
	$res = mysql_query($sql,$db);
	
	// If we have a top level message, we need to update the category, 
	// and change the category of all submessages...
	if ($oldinfo['parent'] == -1) {
		if ($oldinfo['category'] != $cat) {
			changecategory($msg,$cat);
		}
		$return = $msg;
	} else {
		$return = $oldinfo['parent'];
	}
	
	// We have to make sure that the last 
	// comment stuff in this message and its parents is still Ok.
	findlastpost($msg);
	
	return $return;
}

///////////////////////////////////////////////////////////////////////////
// Function: changecategory
// Description: Changes the category of a message and all of it's submessages
//      (recursive)
///////////////////////////////////////////////////////////////////////////
function changecategory($msg,$cat) {
	global $tablename, $db;
	$sql = "UPDATE `$tablename` SET category='$cat' WHERE pid=$msg";
	$res = mysql_query($sql,$db);
	$sql = "SELECT pid FROM $tablename WHERE parent=$msg";
	$res = mysql_query($sql,$db);
	while($row = mysql_fetch_object($res)) {
		changecategory($row->pid,$cat);
	}
}

///////////////////////////////////////////////////////////////////////////
// Function: findlastpost
// Description: find last post information and updates database
//     Recursive (upwards)
///////////////////////////////////////////////////////////////////////////
function findlastpost($msg) {
	global $tablename, $db;
	$info = getthreadinfo($msg);
	$sql = "SELECT lastcomment FROM `$tablename` WHERE `parent`='$msg' ORDER BY lastcomment DESC LIMIT 0,1;";
	$res = mysql_query($sql,$db);
	$num_rows = mysql_num_rows($res);
	if ($num_rows>0) {
		$sqlres=mysql_fetch_array($res);
		$last = $sqlres['lastcomment'];
	} else {
		$last = $info['started'];
	}
	$sql = "UPDATE `$tablename` SET lastcomment='$last' WHERE pid=$msg";
	$res = mysql_query($sql,$db);
	if ($info['parent'] != -1) {
		findlastpost($info['parent']);
	}
}

///////////////////////////////////////////////////////////////////////////
// Function: updatencomments
// Description: Update number of comments related to a post
//     Recursive (downwards)
///////////////////////////////////////////////////////////////////////////
function updatencomments($id) {
	global $tablename, $db;
	$sql = "SELECT pid FROM $tablename WHERE parent=$id";
	$res = mysql_query($sql,$db);
	while($row = mysql_fetch_object($res)) {
		updatencomments($row->pid);
	}
	$sql = "SELECT sum(ncomments) as count FROM $tablename WHERE parent=$id";
	$res = mysql_query($sql,$db);
	$count=mysql_fetch_array($res);
	if ($count['count'] == "") {
		$c = 0;
	} else {
		$c = $count['count'];
	}
	$c += 1;
	$sql = "UPDATE `$tablename` SET ncomments=$c WHERE pid=$id";
	$res = mysql_query($sql,$db);
}

///////////////////////////////////////////////////////////////////////////
// Function: addanswer
// Description: Adds a new answer in a thread to the database
///////////////////////////////////////////////////////////////////////////
function addanswer($subject, $name,$email,$text,$parent) {
	global $_SERVER;
	global $tablename, $db;
	global $config_flood_time;
	global $path;
	global $webmasteremail, $emaillevel;
	
	$threadinfo = getthreadinfo($parent);
	$cat = $threadinfo['category'];
	
	$name = trim($name);
	if(!$ip){
		if(isset($_SERVER['HTTP_X_FORWARDED_FOR'])) { $ip = $_SERVER['HTTP_X_FORWARDED_FOR']; }
		elseif(isset($_SERVER['HTTP_CLIENT_IP'])) { $ip = $_SERVER['HTTP_CLIENT_IP']; }
		if($ip == "") { $ip = $_SERVER['REMOTE_ADDR']; }
		if($ip == "") { $ip = "not detected";}
	}
	
	// Check the message (flood protection, content, IP ban...)
	if (!checkmessage($subject,$name,$email,$text,$ip)) return 0;
	
	// If it's ok, add it in the database
	$time = time();
	// Add the Comment
	$subject = stripslashes($subject);
	$name = stripslashes($name);
	$email = stripslashes($email);
	$text = stripslashes($text);
	$text = replace_comment("add", $text,true);
	$sql ="INSERT INTO `$tablename` VALUES ('', '$ip', '$name', '$subject', '$text', '$time', '$time', '$email', '$parent', '1', '$cat')";
	$res4 = mysql_query($sql,$db);
	$id = mysql_insert_id();
	
	// update the parent's entry
	$sql = "UPDATE `$tablename` SET ncomments=ncomments+1,lastcomment=$time WHERE pid=$parent";
	$res = mysql_query($sql,$db);
	
	
	// Add Flood Protection
	if($config_flood_time != "0" and $config_flood_time != "" ){
		$flood_file = fopen("$path/Data/flood.db.php", "a");
		@flock ($flood_file,2);
		fwrite($flood_file, time()."|$ip|\n");
		@flock ($flood_file,3);
		fclose($flood_file);
	}
	
	// Email webmaster
	if ($emaillevel > 1) {
		$webpage = $_SERVER['PHP_SELF']."?mode=thread&thread=$parent#$id";
		$sebpage = $_SERVER['PHP_SELF'];
		$webserver = $_SERVER['HTTP_HOST'];
		$emailsubject = "Post at $webserver";
		$emailtext = "\nNew post for http://$webserver$sebpage\nAuthor: $name, $email, $ip\nSubject: $subject\nFull link: http://$webserver$webpage\n";
		$emailto = "$webmasteremail";
		// email("webmaster",$emailto,$emailsubject,$emailtext); // Online.net
		mail ($emailto, $emailsubject, $emailtext); // General email function
	}
	
	// End!
	return $id;
}

///////////////////////////////////////////////////////////////////////////
// Function: addthread
// Description: Adds a new thread in the database
///////////////////////////////////////////////////////////////////////////
function addthread($subject,$name,$email,$text,$cat) {
	global $_SERVER;
	global $tablename, $db;
	global $config_flood_time;
	global $path;
	global $webmasteremail, $emaillevel;

	$name = trim($name);
	if(!$ip){
		if(isset($_SERVER['HTTP_X_FORWARDED_FOR'])){ $ip = $_SERVER['HTTP_X_FORWARDED_FOR']; }
		elseif(isset($_SERVER['HTTP_CLIENT_IP']))	{ $ip = $_SERVER['HTTP_CLIENT_IP']; }
		if($ip == "") { $ip = $_SERVER['REMOTE_ADDR']; }
		if($ip == "") { $ip = "not detected";}
	}
	
	// Check the message (flood protection, content, IP ban...)
	if (!checkmessage($subject,$name,$email,$text,$ip)) return 0;
	
	// If it's ok, add it in the database
	$time = time();
	// Add the Comment
	$subject = stripslashes($subject);
	$name = stripslashes($name);
	$email = stripslashes($email);
	$text = stripslashes($text);
	$text = replace_comment("add", $text,true);
	$sql ="INSERT INTO `$tablename` VALUES ('', '$ip', '$name', '$subject', '$text', '$time', '$time', '$email', '-1', '1', '$cat')";
	$res4 = mysql_query($sql,$db);
	$id = mysql_insert_id();

	// Add Flood Protection
	if($config_flood_time != "0" and $config_flood_time != "" ){
		$flood_file = fopen("$path/Data/flood.db.php", "a");
		@flock ($flood_file,2);
		fwrite($flood_file, time()."|$ip\n");
		@flock ($flood_file,3);
		fclose($flood_file);
	}
	
	// Email webmaster
	if ($emaillevel > 0) {
		$webpage = $_SERVER['PHP_SELF'];
		$webserver = $_SERVER['HTTP_HOST'];
		$sebpage = "${webpage}?mode=thread&thread=$id";
		$emailsubject = "Thread at $webserver";
		$emailtext = "\nNew thread at http://${webserver}${webpage}\nAuthor: $name, $email, $ip\nSubject: $subject\nFull link: http://${webserver}$sebpage\n";
		$emailto = "$webmasteremail";
		// email("webmaster",$emailto,$emailsubject,$emailtext); // Online.net
		mail ($emailto, $emailsubject, $emailtext); // General email function
	}
	// End!
	return $id;
}

///////////////////////////////////////////////////////////////////////////
// Function: getnmessages
// Description: Total number of messages
// Optional argument: category
///////////////////////////////////////////////////////////////////////////
function getnmessages($cat) {
	global $tablename, $db;
	if ($cat == 0) {
		$catlimit = "";
	} else {
		$catlimit = " WHERE category=$cat ";
	}
	$sql = "SELECT COUNT(*) as count FROM `$tablename` $catlimit;";
	$res = mysql_query($sql,$db);
	$count=mysql_fetch_array($res);
	if ($count['count'] == "") {
		$c = 0;
	} else {
		$c = $count['count'];
	}
	return $c;
}

///////////////////////////////////////////////////////////////////////////
// Function: getnthreads
// Description: Total number of threads
// Optional argument: category
///////////////////////////////////////////////////////////////////////////
function getnthreads($cat) {
	global $tablename, $db;
	if ($cat == 0) {
		$catlimit = "";
	} else {
		$catlimit = " AND category=$cat ";
	}
	$sql = "SELECT COUNT(*) as count FROM `$tablename` WHERE `parent`='-1' $catlimit;";
	$res = mysql_query($sql,$db);
	$count=mysql_fetch_array($res);
	if ($count['count'] == "") {
		$c = 0;
	} else {
		$c = $count['count'];
	}
	return $c;
}

///////////////////////////////////////////////////////////////////////////
// Function: getnpagesthreads
// Description: Number of pages needed to display list of threads
// Optional argument: category
///////////////////////////////////////////////////////////////////////////
function getnpagesthread($cat=0) {
	global $nthreadsperpage;
	$nthread=getnthreads($cat);
	if ($nthread<2) {
		$npages  = 1;
	} else { 
		$npages = ceil(($nthread-1)/$nthreadsperpage);
	}
	return $npages;
}


///////////////////////////////////////////////////////////////////////////
// Function: getnpagesthreads
// Description: Number of pages needed to display list of threads
// Optional argument: category
///////////////////////////////////////////////////////////////////////////
function getnpagescomments($thread) {
	global $ncommentsperpage;
	$ncomments=getnchildren($thread);
	if ($ncomments<2) {
		$npages  = 1;
	} else { 
		$npages = ceil(($ncomments)/$ncommentsperpage);
	}
	return $npages;
}


///////////////////////////////////////////////////////////////////////////
// Function: getnchildren
// Description: Number of posts in a thread
// Argument: thread ID
///////////////////////////////////////////////////////////////////////////
function getnchildren($threadid) {
	global $tablename, $db;
	$sql = "SELECT COUNT(*) as count FROM `$tablename` WHERE `parent`='$threadid';";
	$res = mysql_query($sql,$db);
	$count=mysql_fetch_array($res);
	if ($count['count'] == "") {
		$c = 0;
	} else {
		$c = $count['count'];
	}
	return $c;
}

///////////////////////////////////////////////////////////////////////////
// Function: lastpostinfoall() 
// Description: Information about the last post available (who, when)
///////////////////////////////////////////////////////////////////////////
function lastpostinfoall() {
	global $tablename, $db;
	$sql = "SELECT date,author FROM `$tablename` ORDER BY date DESC LIMIT 0,1;";
	$res = mysql_query($sql,$db);
	$info=mysql_fetch_array($res);
	$last['date'] = $info['date'];
	$last['author'] = $info['author'];
	return $last;
}

///////////////////////////////////////////////////////////////////////////
// Function: lastpostinfoall() 
// Description: Information about the last post available in a 
//       given thread (who, when)
// Argument: thread ID
///////////////////////////////////////////////////////////////////////////
function lastpostinfo($threadid) {
	global $tablename, $db;
	$sql = "SELECT date,author FROM `$tablename` WHERE `parent`='$threadid' ORDER BY date DESC LIMIT 0,1;";
	$res = mysql_query($sql,$db);
	$info=mysql_fetch_array($res);
	$last['date'] = $info['date'];
	$last['author'] = $info['author'];
	return $last;
}

///////////////////////////////////////////////////////////////////////////
// Function: getthreadlist 
// Description: List of thread, with information
// Argument: page number, category, sort order
//   Sort order can be "thread", "post" or "nposts"
// Returns an array of array with the info...
///////////////////////////////////////////////////////////////////////////
function getthreadlist ($page, $cat, $sort) {
	global $tablename, $db;
	global $nthreadsperpage;
	
	$threads = array();
	$lowlimit = $nthreadsperpage*($page-1);
	if ($cat == 0) {
		$catlimit = "";
	} else {
		$catlimit = " AND category=$cat ";
	}
	if ($sort == "nposts") {
		$sortstring = " ORDER BY ncomments DESC ";
	} else if ($sort == "post") {
		$sortstring = " ORDER BY lastcomment DESC ";
	} else {
		$sortstring = " ORDER BY date DESC ";
	}
	$sql = "SELECT pid,author,subject,date,category,ncomments FROM $tablename WHERE parent=\"-1\" $catlimit $sortstring LIMIT $lowlimit,$nthreadsperpage";
	$res = mysql_query($sql,$db);
	while($row = mysql_fetch_object($res)) {
		$subject = $row->subject;
		$author = $row->author;
		$id = $row->pid;
		$nposts = $row->ncomments;
		$start = $row->date;
		if ($nposts == 1) {
			$lastpost = $row->date;
			$lastpostauthor = $row->author;
		} else {
			$last = lastpostinfo($id);
			$lastpost = $last['date'];
			$lastpostauthor = $last['author'];
		}
		$thisthread = array( 'id' => $id, 'subject' => "$subject", 'author' => "$author", 'nposts' => $nposts, 'lastpost' => $lastpost, 'lastpostauthor' => "$lastpostauthor", 'started' => $start, 'category' => $row->category);
		$threads[] = $thisthread;
	}
	return $threads;
}

///////////////////////////////////////////////////////////////////////////
// Function: formcategories
// Description: Returns a form to choose a category
// Argument: 
//   - cat: selected category
//   - showall: 1 if you want "All" as available choice
//   - showprivate: 1 to also show categories where only admin can post
//   - fullform: 1 if you want a full form, 0 if you just want a select
// Returns a string with the form
///////////////////////////////////////////////////////////////////////////
function formcategories($cat, $showall, $showprivate,$fullform) {
	global $tablename,$db;
	global $_SERVER;
	global $strings;
	
	$form = "";
	if ($fullform) $form = "<form method='post' action='".$_SERVER['PHP_SELF']."'>\n";
	$form = $form."<SELECT NAME=\"cat\">";
	if ($showall) {
		if ($cat==0) { 
			$form = $form."<option value=0 selected>All</option>";
		} else {
			$form = $form."<option value=0>All</option>";
		}
	}
	if (!$showprivate ) {
		$private = " WHERE public = 1";
	} else {
		$private = "";
	}
	$sql = "SELECT * FROM ${tablename}_cat $private";
	$res = mysql_query($sql,$db);
	while($row = mysql_fetch_object($res)) {
		$id = $row->id;
		$name = $row->name;
		if ($cat==$id) {
			$form = $form."<option value=$id selected>$name</option>";
		} else {
			$form = $form."<option value=$id>$name</option>";
		}
	}
	$form = $form."</select>";
	if ($fullform) $form = $form."<input type=\"submit\" value=\"".$strings['go']."\"></form>";
	return $form;
}

///////////////////////////////////////////////////////////////////////////
// Function: categorylist
// Description: Returns a list of categories 
// Returns an array (id -> name)
///////////////////////////////////////////////////////////////////////////
function categorylist() {
	global $tablename,$db;
	$sql = "SELECT * FROM ${tablename}_cat";
	$res = mysql_query($sql,$db);
	while($row = mysql_fetch_object($res)) {
		$cat[$row->id] = $row->name;
	}
	return $cat;
}

///////////////////////////////////////////////////////////////////////////
// Function: npostcat
// Description: Number of posts in a category
///////////////////////////////////////////////////////////////////////////
function npostcat($id) {
	global $tablename, $db;
	$sql = "SELECT COUNT(*) as count FROM `$tablename` WHERE `category`='$id';";
	$res = mysql_query($sql,$db);
	$count=mysql_fetch_array($res);
	if ($count['count'] == "") {
		$c = 0;
	} else {
		$c = $count['count'];
	}
	return $c;
}

///////////////////////////////////////////////////////////////////////////
// Function: nthreadcat
// Description: Number of threads in a category
///////////////////////////////////////////////////////////////////////////
function nthreadcat($id) {
	global $tablename, $db;
	$sql = "SELECT COUNT(*) as count FROM `$tablename` WHERE `parent`='-1' AND `category`='$id';";
	$res = mysql_query($sql,$db);
	$count=mysql_fetch_array($res);
	if ($count['count'] == "") {
		$c = 0;
	} else {
		$c = $count['count'];
	}
	return $c;
}

///////////////////////////////////////////////////////////////////////////
// Function: categoryarray
// Description: Returns an array with categories and their info
///////////////////////////////////////////////////////////////////////////
function categoryarray() {
	global $tablename,$db;
	$cat = array();
	$sql = "SELECT * FROM ${tablename}_cat";
	$res = mysql_query($sql,$db);
	while($row = mysql_fetch_object($res)) {
		$nposts = npostcat($row->id);
		$nthread = nthreadcat($row->id);
		$cat[] = array ('id' => $row->id, 'name' => $row->name, 'public' => $row->public, 'nposts'=>$nposts, 'nthreads'=>$nthread);
	}
	return $cat;
}

///////////////////////////////////////////////////////////////////////////
// Function: categorylistfree
// Description: Returns a list of public categories
// Returns an array (id -> name)
///////////////////////////////////////////////////////////////////////////
function categorylistfree() {
	global $tablename,$db;
	$sql = "SELECT * FROM ${tablename}_cat WHERE public=1";
	$res = mysql_query($sql,$db);
	while($row = mysql_fetch_object($res)) {
		$cat[$row->id] = $row->name;
	}
	return $cat;
}

///////////////////////////////////////////////////////////////////////////
// Function: changecatmode
// Description: changes the mode of a category (public/private)
///////////////////////////////////////////////////////////////////////////
function changecatmode($id) {
	global $tablename,$db;
	global $admin;
	if (!$admin) {return;}
	$sql = "SELECT public FROM ${tablename}_cat WHERE id=$id";
	$res = mysql_query($sql,$db);
	while($row = mysql_fetch_object($res)) {
		$mode = $row->public;
	}
	if ($mode == 1) {
		$sql = "UPDATE ${tablename}_cat SET public=0 WHERE id=$id";
	} else {
		$sql = "UPDATE ${tablename}_cat SET public=1 WHERE id=$id";
	}
	$res = mysql_query($sql,$db);
	return;
}

///////////////////////////////////////////////////////////////////////////
// Function: newcategory
// Description: create a new category
///////////////////////////////////////////////////////////////////////////
function newcategory($name, $public) {
	global $tablename,$db;
	global $admin;
	if (!$admin) {return;}
	$sql ="INSERT INTO `${tablename}_cat` VALUES ('', '$name', '$public')";
	$res = mysql_query($sql,$db);
	return;
}


///////////////////////////////////////////////////////////////////////////
// Function: deletecategory
// Description: deletes a category, moves all post from this category 
//       into the default one (id=1)
///////////////////////////////////////////////////////////////////////////
function deletecategory($id) {
	global $tablename,$db;
	global $admin;
	if (!$admin) {return;}
	$sql = "UPDATE ${tablename} SET category=1 WHERE category=$id";
	$res = mysql_query($sql,$db);
	$sql = "DELETE FROM ${tablename}_cat WHERE id=$id";
	$res = mysql_query($sql,$db);
	return;
}

///////////////////////////////////////////////////////////////////////////
// Function: renamecategory
// Description: renames a category
///////////////////////////////////////////////////////////////////////////
function renamecategory($id,$name) {
	global $tablename,$db;
	global $admin;
	if (!$admin) {return;}
	$sql = "UPDATE ${tablename}_cat SET name='$name' WHERE id=$id";
	$res = mysql_query($sql,$db);
	return;
}

///////////////////////////////////////////////////////////////////////////
// Function: getthreadinfo
// Description: Information about a thread (author, date, content...)
// Argument: thread ID
// Returns an array with the info...
///////////////////////////////////////////////////////////////////////////
function getthreadinfo($threadid) {
	global $tablename,$db;
	$sql = "SELECT * FROM $tablename WHERE pid=\"$threadid\"";
	$res = mysql_query($sql,$db);
	while($row = mysql_fetch_object($res)) {
		$subject = $row->subject;
		$author = $row->author;
		$message = $row->message;
		$start = $row->date;
		$cat = $row->category;
		$email = $row->email;
		$ip = $row->ip;
		$parent = $row->parent;
		$ncomments = $row->ncomments;
		$thisthread = array( 'id' => $threadid, 'subject' => "$subject", 'author' => "$author", 'message' => $message, 'started' => $start, 'category' => $cat, 'email' => "$email", 'ip'=>"$ip", 'parent'=>$parent, 'nposts'=>$ncomments);
	}
	return $thisthread;
}

///////////////////////////////////////////////////////////////////////////
// Function: getthreadcomments
// Description: List of comments in a thread, with information
// Argument: thread ID
// Returns an array of array with the info...
///////////////////////////////////////////////////////////////////////////
function getthreadcomments($threadid,$page=1) {
	global $tablename,$db;
	global $ncommentsperpage;
	
	$lowlimit = $ncommentsperpage*($page-1);
	$comments = array();
	$sql = "SELECT pid FROM $tablename WHERE parent=$threadid ORDER BY lastcomment ASC LIMIT $lowlimit,$ncommentsperpage";
	$res = mysql_query($sql,$db);
	while($row = mysql_fetch_object($res)) {
		$comments[] = getthreadinfo($row->pid);
	}
	return $comments;
}

///////////////////////////////////////////////////////////////////////////
// Function: deletepost
// Description: Deletes a post and all the answers
// Returns an array (id -> name)
///////////////////////////////////////////////////////////////////////////
function deletepost($id) {
	global $tablename,$db;
	global $admin;
	if (!$admin) {return 0;}
	$sql = "SELECT pid FROM $tablename WHERE parent=$id";
	$res = mysql_query($sql,$db);
	while($row = mysql_fetch_object($res)) {
		deletepost($row->pid);
	}
	$sql = "DELETE FROM $tablename WHERE pid=$id";
	$res = mysql_query($sql,$db);
}

///////////////////////////////////////////////////////////////////////////
// Function: banIP
// Description: Bans an IP address
///////////////////////////////////////////////////////////////////////////
function banIP ($add_ip) {
	global $admin;
	global $path;
	if (!$admin) {return 0;}
	if (!check_ip_address($add_ip)) {return 0;}
	$all_ip = file("$path/Data/ipban.db.php");
	$exist = FALSE;
	foreach($all_ip as $ip_line) {
		$ip_arr = explode("|", $ip_line);
		if($ip_arr[0] == $add_ip){ $exist = TRUE; }
	}
	if(!$exist) {
		$new_ips = fopen("$path/Data/ipban.db.php", "a");
		$add_ip = stripslashes( preg_replace(array("'\|'",), array("I",), $add_ip) );
		fwrite($new_ips, "$add_ip|0||\n");
		fclose($new_ips);
	}
	return 1;
}

///////////////////////////////////////////////////////////////////////////
// Function: removebanIP
// Description: Removes a ban of IP
///////////////////////////////////////////////////////////////////////////
function removebanIP ($remove_ip) {
	global $admin;
	global $path;
	if (!$admin) {return 0;}
	$old_ips = file("$path/Data/ipban.db.php");
	$new_ips = fopen("$path/Data/ipban.db.php", "w");
	foreach($old_ips as $old_ip_line){
		$ip_arr = explode("|", $old_ip_line);
		if($ip_arr[0] != stripslashes($remove_ip)){
			fwrite($new_ips, $old_ip_line);
		}
	}
	fclose($new_ips);
}

///////////////////////////////////////////////////////////////////////////
// Function: listbannedIP
// Description: Returns a list of banned IP
///////////////////////////////////////////////////////////////////////////
function listbannedIP() {
	global $path;
	$ban = array();
	$all_ips = file("$path/Data/ipban.db.php");
	foreach($all_ips as $ip_line) {
		if(!eregi("<\?",$ip_line)) {
			$ip_arr = explode("|", $ip_line);
			$ip_arr[0] = stripslashes( preg_replace(array("'\"'", "'\''"), array("&quot;", "&#039;"), $ip_arr[0]) );
			$ban[$ip_arr[0]] = $ip_arr[1];
		}
	}
	return $ban;
}

///////////////////////////////////////////////////////////////////////////
// Function: search
// Description: Search messages matching a string
// Returns: Array with PID of matching messages
///////////////////////////////////////////////////////////////////////////
function search($string,$page) {
	global $tablename,$db;
	global $nsearchresultsperpage;
	
	$lowlimit = $nsearchresultsperpage*($page-1);
	$string = preg_replace("/[^\s\w]/i", "", preg_replace("/\s{2,}/i", " ", stripslashes(trim($string))));
	$sList = explode(" ", $string);
	$buildq = "";
	foreach($sList as $term) $buildq .= " (`subject` LIKE '%".addslashes($term)."%' OR `message` LIKE '%".addslashes($term)."%') AND";
	$sql = "SELECT pid FROM `$tablename` WHERE".preg_replace("/\sAND$/i", "", $buildq)." GROUP BY pid LIMIT $lowlimit, $nsearchresultsperpage;";
	$res = mysql_query($sql,$db);
	$mList = array();
	while($row = mysql_fetch_object($res)) {
		$mList[] = $row->pid;
	}
	$mList = array_unique($mList);
	arsort($mList);
	return $mList;
} 

function npagessearchresults($string) {
	global $nsearchresultsperpage;
	global $tablename,$db;
	
	$string = preg_replace("/[^\s\w]/i", "", preg_replace("/\s{2,}/i", " ", stripslashes(trim($string))));
	$sList = explode(" ", $string);
	$buildq = "";
	foreach($sList as $term) $buildq .= " (`subject` LIKE '%".addslashes($term)."%' OR `message` LIKE '%".addslashes($term)."%') AND";
	$sql = "SELECT COUNT(*) as count FROM `$tablename` WHERE".preg_replace("/\sAND$/i", "", $buildq).";";
	$res = mysql_query($sql,$db);
	$count=mysql_fetch_array($res);
	if ($count['count'] == "") {
		$c = 0;
	} else {
		$c = $count['count'];
	}
	if ($c<2) {
		$npages  = 1;
	} else { 
		$npages = ceil(($c-1)/$nsearchresultsperpage);
	}
	return $npages;
}

///////////////////////////////////////////////////////////////////////////
// Function: searchresults
// Description: Search messages matching a string, and get info about the results
// Returns: Array with information, for each matching messages
///////////////////////////////////////////////////////////////////////////
function searchresults($string,$page) {
	$mList = search($string,$page);
	$results = array();
	foreach($mList as $pid) {
		$info = getthreadinfo($pid);
		$thisone['id'] = $pid;
		$thisone['subject'] = $info['subject'];
		$thisone['category'] = $info['category'];
		$thisone['date'] = $info['started'];
		$thisone['author'] =  $info['author'];
		$parent = $info['parent'];
		if ($parent == '-1') {
			$thisone['thread'] = $pid;
			$thisone['threadtitle'] = $info['subject'];
			$thisone['nposts'] =  $info['nposts'];
			$thisone['started'] =  $info['started'];
		} else {
			$parentinfo = getthreadinfo($parent);
			$thisone['thread'] = $parent;
			$thisone['threadtitle'] = $parentinfo['subject'];
			$thisone['nposts'] =  $parentinfo['nposts'];
			$thisone['started'] =  $parentinfo['started'];
		}
		$results[] = $thisone;
	}
	return $results;
} 

///////////////////////////////////////////////////////////////////////////
// Function: securecat
// Description: Make sure that the requested category exists. If not, set it
//    to 0
// Returns: a secure category number
///////////////////////////////////////////////////////////////////////////
function securecat($cat) {
	global $tablename,$db;
	if ($cat == 0) {return 0;} // This is allowed!
	//echo "Looking at category $cat<br>";
	$sql = "SELECT id FROM ${tablename}_cat WHERE id=$cat";
	//echo "SQL is $sql<br>";
	$res = mysql_query($sql,$db);
	$num_rows = mysql_num_rows($res);
	//echo "We have $num_rows<br>";
	if ($num_rows < 1) $cat = 0;
	return $cat;
} 

///////////////////////////////////////////////////////////////////////////
// Function: securethread
// Description: Make sure that the requested thread exists. If not, return
//   the first thread in the defined category
// Returns: a secure thread number
///////////////////////////////////////////////////////////////////////////
function securethread($thread,$cat) {
	global $tablename,$db;
	//echo "Looking at thread $thread<br>";
	if ($cat == 0) {
		$sql = "SELECT pid FROM ${tablename} WHERE pid=$thread AND parent=-1";
	} else {
		$sql = "SELECT pid FROM ${tablename} WHERE pid=$thread AND parent=-1 AND category=$cat";
	}
	$res = mysql_query($sql,$db);
	$num_rows = mysql_num_rows($res);
	//echo "We have $num_rows<br>";
	if ($num_rows < 1) {
		if ($cat == 0) {
			$sql = "SELECT pid FROM ${tablename} WHERE parent=-1 ORDER BY pid ASC LIMIT 0,1";
		} else {
			$sql = "SELECT pid FROM ${tablename} WHERE parent=-1 AND category=$cat ORDER BY pid ASC LIMIT 0,1";
		}
		$res = mysql_query($sql,$db);
		$fetch=mysql_fetch_array($res);
		$thread = $fetch['pid'];
	}
	return $thread;
} 

///////////////////////////////////////////////////////////////////////////
// Function: securepost
// Description: Make sure that the requested post exists. If not, return
//   the first post in the defined thread
// Returns: a secure post number
///////////////////////////////////////////////////////////////////////////
function securepost($post,$thread) {
	global $tablename,$db;
	// echo "Looking at post $post<br>";
	if ($post == $thread) {return $post;} // Should have been fixed in securethread
	if ($post == 0) {return 0;} // This is allowed
	$sql = "SELECT pid FROM ${tablename} WHERE pid=$post AND parent=$thread";
	$res = mysql_query($sql,$db);
	$num_rows = mysql_num_rows($res);
	// echo "We have $num_rows<br>";
	if ($num_rows < 1) {
		$post = $thread;
	}
	return $post;
} 
?>
